# PA165 - Movie Recommendation Project

## About Project

Our team project in Java Spring Boot creates a set of microservices that handle movie recommendation.
Each microservice performs a specific function such as recommending movies based on genre, user
preferences or ratings. The microservices making the system scalable and easy to maintain.

### Developers:

    - Daniel Múčka (@xmucka) - Team leader
    - Petr Wehrenberg (@xwehrenb)
    - Vojtěch Malý (@xmaly1)
    - Marek Mišík (@xmisik)

### Assigment:

The web application is a catalogue of movies of different genres. Each movie has a title, description, 
film director, and list of actors, and image(s) from the main playbill. Each movie is categorized in 
one or more genres. Only the administrator can create, remove and update the list of movies. Users 
can rate the movies according to different criteria (e.g how novel are the ideas of the movie, their 
final score, etc…). The main feature of the system is that users can pick one movie and get the list
of similar movies and / or movies that were liked the most by other users watching the same movie 
(no need of complex algorithms, some simple recommendation is enough!).

## Project structure

Project contains modules as microservices.

### module-main

`mvn -pl module-main spring-boot:run`

Description: This module serves as the entry point for the entire
system. It initializes all the microservices and manages the communication between them.


### module-movie

`mvn -pl module-movie spring-boot:run`

Description: This module manages the movie data and provides information such 
as movie titles, genres, and release dates.


### module-rating

`mvn -pl module-rating spring-boot:run`

Description: This module handles the user rating data and stores it in a database.
It provides an interface to rate movies.


### module-recommendation

`mvn -pl module-recommendation spring-boot:run`

Description: This module contains the algorithms responsible for generating movie recommendations.
It uses user rating and movie data from other modules to create personalized recommendations for each user.


### module-user

`mvn -pl module-user spring-boot:run`

Description: This module manages user data such as name, email, and password.
It provides an interface for user registration, login, and authentication. It communicates with other modules.

## Diagrams
### Use case

![Use case diagram](docs/usecase.png)
